<script lang="ts">
  import { mousePos } from 'sveltronics';
  let { x, y } = mousePos();

  export let showPopup = false;
  let popupEle: HTMLElement;
  let transformX = '-50%';

  $: if (showPopup) {
    // Check if the cursor is too close to the left edge of the screen
    if ($x < popupEle.offsetWidth / 2) {
      transformX = '0%'; // Align the left edge of the popup with the cursor
    } else {
      transformX = '-50%'; // Center the popup over the cursor
    }
  }
</script>

<div
  class="popup"
  bind:this={popupEle}
  class:show={showPopup}
  style="top: {$y}px; left: {$x}px; transform: translate({transformX}, -100%);"
>
  <slot />
</div>

<style>
  .popup {
    position: fixed;
    pointer-events: none; /* Makes sure the popup doesn't interfere with mouse events */
    transform: translate(-50%, -100%); /* Adjust position relative to the cursor */
    display: none; /* Hide by default */
  }

  /* Only display the popup when showPopup is true */
  .popup.show {
    display: block;
  }
</style>
